//   ==================================================================
//   >>>>>>>>>>>>>>>>>>>>>>> COPYRIGHT NOTICE <<<<<<<<<<<<<<<<<<<<<<<<<
//   ------------------------------------------------------------------
//   Copyright (c) 2006 by Lattice Semiconductor Corporation
//   ------------------------------------------------------------------
//
//   IMPORTANT: THIS FILE IS AUTO-GENERATED BY THE LatticeMico32 System.
//
//   Permission:
//
//      Lattice Semiconductor grants permission to use this code
//      via the Lattice Open IP core license agreement.  Other use
//      of this code, including the selling or duplication of any
//      portion is strictly prohibited.
//
//   Disclaimer:
//
//      Lattice Semiconductor provides no warranty regarding the use or
//      functionality of this code. It is the user's responsibility to
//      verify their design for consistency and functionality through
//      the use of formal verification methods.
//
//   --------------------------------------------------------------------
//
//                  Lattice Semiconductor Corporation
//                  5555 NE Moore Court
//                  Hillsboro, OR 97214
//                  U.S.A
//
//                  TEL: 1-800-Lattice (USA and Canada)
//                         503-286-8001 (other locations)
//
//                  web: http://www.latticesemi.com/
//                  email: techsupport@latticesemi.com
//
//   --------------------------------------------------------------------
//
//      Project:           platform1
//      File:              platform1.v
//      Date:              ke, 13 tammi 2010 13:28:58 EET
//      Version:           7.1.00.78
//      Targeted Family:   LFE2M20E-5F256C
//
//   =======================================================================

`timescale 1ns / 100 ps
module arbiter2(
// Multiple Master Port0
WBM0_ADR_O,
WBM0_DAT_O,
WBM0_DAT_I,
WBM0_SEL_O,
WBM0_WE_O,
WBM0_ACK_I,
WBM0_ERR_I,
WBM0_RTY_I,
WBM0_CTI_O,
WBM0_BTE_O,
WBM0_LOCK_O,
WBM0_CYC_O,
WBM0_STB_O,
// Multiple Master Port1
WBM1_ADR_O,
WBM1_DAT_O,
WBM1_DAT_I,
WBM1_SEL_O,
WBM1_WE_O,
WBM1_ACK_I,
WBM1_ERR_I,
WBM1_RTY_I,
WBM1_CTI_O,
WBM1_BTE_O,
WBM1_LOCK_O,
WBM1_CYC_O,
WBM1_STB_O,
// Single Slave Port
WBS_ADR_I,
WBS_DAT_I,
WBS_DAT_O,
WBS_SEL_I,
WBS_WE_I,
WBS_ACK_O,
WBS_ERR_O,
WBS_RTY_O,
WBS_CTI_I,
WBS_BTE_I,
WBS_LOCK_I,
WBS_CYC_I,
WBS_STB_I,
clk,reset);
input clk, reset;
input [31:0]WBM0_ADR_O;
input [31:0]WBM0_DAT_O;
output [31:0]WBM0_DAT_I;
input [3:0]WBM0_SEL_O;
input  WBM0_WE_O;
output  WBM0_ACK_I;
output  WBM0_ERR_I;
output  WBM0_RTY_I;
input [2:0]WBM0_CTI_O;
input [1:0]WBM0_BTE_O;
input  WBM0_LOCK_O;
input  WBM0_CYC_O;
input  WBM0_STB_O;
input [31:0]WBM1_ADR_O;
input [31:0]WBM1_DAT_O;
output [31:0]WBM1_DAT_I;
input [3:0]WBM1_SEL_O;
input  WBM1_WE_O;
output  WBM1_ACK_I;
output  WBM1_ERR_I;
output  WBM1_RTY_I;
input [2:0]WBM1_CTI_O;
input [1:0]WBM1_BTE_O;
input  WBM1_LOCK_O;
input  WBM1_CYC_O;
input  WBM1_STB_O;
output [31:0]WBS_ADR_I;
output [31:0]WBS_DAT_I;
input [31:0]WBS_DAT_O;
output [3:0]WBS_SEL_I;
output  WBS_WE_I;
input  WBS_ACK_O;
input  WBS_ERR_O;
input  WBS_RTY_O;
output [2:0]WBS_CTI_I;
output [1:0]WBS_BTE_I;
output  WBS_LOCK_I;
output  WBS_CYC_I;
output  WBS_STB_I;
reg [2-1:0] 		selected; // which master is selected.
reg locked;
always @(posedge clk or posedge reset)
 begin
if (reset) begin
	selected <= 0;
	locked   <= 0;
end else begin
if (selected == 0) begin
 if (WBM0_STB_O) begin
 selected <= 2'd1;
 locked   <= WBM0_LOCK_O;
end
else
 if (WBM1_STB_O) begin
 selected <= 2'd2;
 locked   <= WBM1_LOCK_O;
end
end
else if (selected == 2'd1) begin
if ((WBS_ACK_O | WBS_ERR_O | locked) && (WBM0_CTI_O == 3'b000 || WBM0_CTI_O == 3'b111 || locked) && 
!WBM0_LOCK_O)
begin selected <= 0; locked <= 0; end
end
else if (selected == 2'd2) begin
if ((WBS_ACK_O | WBS_ERR_O | locked) && (WBM1_CTI_O == 3'b000 || WBM1_CTI_O == 3'b111 || locked) && 
!WBM1_LOCK_O)
begin selected <= 0; locked <= 0; end
end
end end 
assign WBS_ADR_I = 
(selected == 2'd1 ? WBM0_ADR_O : 
(selected == 2'd2 ? WBM1_ADR_O : 
0));
assign WBS_DAT_I = 
(selected == 2'd1 ? WBM0_DAT_O : 
(selected == 2'd2 ? WBM1_DAT_O : 
0));
assign WBS_SEL_I = 
(selected == 2'd1 ? WBM0_SEL_O : 
(selected == 2'd2 ? WBM1_SEL_O : 
0));
assign WBS_WE_I = 
(selected == 2'd1 ? WBM0_WE_O : 
(selected == 2'd2 ? WBM1_WE_O : 
0));
assign WBS_CTI_I = 
(selected == 2'd1 ? WBM0_CTI_O : 
(selected == 2'd2 ? WBM1_CTI_O : 
0));
assign WBS_BTE_I = 
(selected == 2'd1 ? WBM0_BTE_O : 
(selected == 2'd2 ? WBM1_BTE_O : 
0));
assign WBS_LOCK_I = 
(selected == 2'd1 ? WBM0_LOCK_O : 
(selected == 2'd2 ? WBM1_LOCK_O : 
0));
assign WBS_CYC_I = 
(selected == 2'd1 ? WBM0_CYC_O : 
(selected == 2'd2 ? WBM1_CYC_O : 
0));
assign WBS_STB_I = 
(selected == 2'd1 ? WBM0_STB_O : 
(selected == 2'd2 ? WBM1_STB_O : 
0));
assign WBM0_DAT_I = WBS_DAT_O;
assign WBM0_ACK_I = (selected == 2'd1 ? WBS_ACK_O : 0);
assign WBM0_ERR_I = (selected == 2'd1 ? WBS_ERR_O : 0);
assign WBM0_RTY_I = (selected == 2'd1 ? WBS_RTY_O : 0);
assign WBM1_DAT_I = WBS_DAT_O;
assign WBM1_ACK_I = (selected == 2'd2 ? WBS_ACK_O : 0);
assign WBM1_ERR_I = (selected == 2'd2 ? WBS_ERR_O : 0);
assign WBM1_RTY_I = (selected == 2'd2 ? WBS_RTY_O : 0);
endmodule
`include "system_conf.v"
`include "../components/gpio/rtl/verilog/gpio.v"
`include "../components/gpio/rtl/verilog/tpio.v"
`include "../components/wb_ebr_ctrl/rtl/verilog/wb_ebr_ctrl.v"
`include "../components/ts_mac_top_v31/rtl/verilog/tsmac_include_all.v"
`include "../components/timer/rtl/verilog/timer.v"
`include "../components/wb_ddr2_ctl_v67/rtl/verilog/ddr_include_all.v"
`include "../components/lm32_top/rtl/verilog/lm32_include_all.v"
`include "../components/uart_core/rtl/verilog/uart_core.v"
`include "../components/spi/rtl/verilog/wb_spi.v"
`include "../components/slave_passthru/rtl/verilog/slave_passthru.v"
`include "../components/slave_passthru/rtl/verilog/passthru.v"
`include "lplib.v"


module platform1 ( 
	clk_i,reset_n
, gpioPIO_OUT
, ts_mac_coregtx_clk
, ts_mac_corerxmac_clk
, ts_mac_coretxmac_clk
, ts_mac_coretx_clk
, ts_mac_coremdc
, ts_mac_coresys_clk
, ts_mac_corerx_clk
, ts_mac_corerxd
, ts_mac_corerx_dv
, ts_mac_corerx_er
, ts_mac_corecol
, ts_mac_corecrs
, ts_mac_coretxd
, ts_mac_coretx_en
, ts_mac_coretx_er
, ts_mac_coremdio
, ddr2_sdramem_ddr_data
, ddr2_sdramem_ddr_dqs
, ddr2_sdramem_ddr_clk
, ddr2_sdramem_ddr_cke
, ddr2_sdramem_ddr_ras_n
, ddr2_sdramem_ddr_cas_n
, ddr2_sdramem_ddr_we_n
, ddr2_sdramem_ddr_cs_n
, ddr2_sdramem_ddr_odt
, ddr2_sdramem_ddr_dm
, ddr2_sdramem_ddr_ba
, ddr2_sdramem_ddr_addr
, uartSIN
, uartSOUT
, spiMISO_MASTER
, spiMOSI_MASTER
, spiSS_N_MASTER
, spiSCLK_MASTER
, slave_passthruclk
, slave_passthrurst
, slave_passthruslv_adr
, slave_passthruslv_master_data
, slave_passthruslv_slave_data
, slave_passthruslv_strb
, slave_passthruslv_cyc
, slave_passthruslv_ack
, slave_passthruslv_err
, slave_passthruslv_rty
, slave_passthruslv_sel
, slave_passthruslv_we
, slave_passthruslv_bte
, slave_passthruslv_cti
, slave_passthruslv_lock
, slave_passthruintr_active_high
);
input	clk_i, reset_n;
genvar i;
wire [31:0] zwire = 32'hZZZZZZZZ;
wire [31:0] zerowire = 32'h00000000;
wire [31:0] SHAREDBUS_ADR_I;
wire [31:0] SHAREDBUS_DAT_I;
wire [31:0] SHAREDBUS_DAT_O;
wire [3:0] SHAREDBUS_SEL_I;
wire   SHAREDBUS_WE_I;
wire   SHAREDBUS_ACK_O;
wire   SHAREDBUS_ERR_O;
wire   SHAREDBUS_RTY_O;
wire [2:0] SHAREDBUS_CTI_I;
wire [1:0] SHAREDBUS_BTE_I;
wire   SHAREDBUS_LOCK_I;
wire   SHAREDBUS_CYC_I;
wire   SHAREDBUS_STB_I;
wire SHAREDBUS_en;

wire [31:0] gpioGPIO_DAT_O;
wire   gpioGPIO_ACK_O;
wire   gpioGPIO_ERR_O;
wire   gpioGPIO_RTY_O;
wire gpioGPIO_en;
wire gpioIRQ_O;
output [4-1:0] gpioPIO_OUT;

wire [31:0] ebrEBR_DAT_O;
wire   ebrEBR_ACK_O;
wire   ebrEBR_ERR_O;
wire   ebrEBR_RTY_O;
wire ebrEBR_en;

wire [31:0] ts_mac_coreA_DAT_O;
wire   ts_mac_coreA_ACK_O;
wire   ts_mac_coreA_ERR_O;
wire   ts_mac_coreA_RTY_O;
wire ts_mac_coreA_en;
wire ts_mac_coreINTR_N;
output  ts_mac_coregtx_clk;
output  ts_mac_corerxmac_clk;
output  ts_mac_coretxmac_clk;
input  ts_mac_coretx_clk;
`ifdef MIIM_MODULE
output  ts_mac_coremdc;
`endif // MIIM_MODULE
input  ts_mac_coresys_clk;
input  ts_mac_corerx_clk;
input [7:0]  ts_mac_corerxd;
input  ts_mac_corerx_dv;
input  ts_mac_corerx_er;
`ifndef GBE_MAC
input  ts_mac_corecol;
`endif // !GBE_MAC
`ifndef GBE_MAC
input  ts_mac_corecrs;
`endif // !GBE_MAC
output [7:0]  ts_mac_coretxd;
output  ts_mac_coretx_en;
output  ts_mac_coretx_er;
`ifdef MIIM_MODULE
inout  ts_mac_coremdio;
`endif // MIIM_MODULE

wire [31:0] timer0S_DAT_O;
wire   timer0S_ACK_O;
wire   timer0S_ERR_O;
wire   timer0S_RTY_O;
wire timer0S_en;
wire timer0S_INT_O;

wire [31:0] ddr2_sdramDDR2_DAT_O;
wire   ddr2_sdramDDR2_ACK_O;
wire   ddr2_sdramDDR2_ERR_O;
wire   ddr2_sdramDDR2_RTY_O;
wire ddr2_sdramDDR2_en;
inout [`DATA_WIDTH-1:0]  ddr2_sdramem_ddr_data /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_data IO_TYPE SSTL18_II;
inout [`DQS_WIDTH-1:0]  ddr2_sdramem_ddr_dqs /* synthesis IO_TYPE="SSTL18D_II" */;
//pragma attribute ddr2_sdramem_ddr_dqs IO_TYPE SSTL18D_II;
output [`CLKO_WIDTH-1:0]  ddr2_sdramem_ddr_clk /* synthesis IO_TYPE="SSTL18D_II" */;
//pragma attribute ddr2_sdramem_ddr_clk IO_TYPE SSTL18D_II;
output [`CKE_WIDTH-1:0]  ddr2_sdramem_ddr_cke /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_cke IO_TYPE SSTL18_II;
output  ddr2_sdramem_ddr_ras_n /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_ras_n IO_TYPE SSTL18_II;
output  ddr2_sdramem_ddr_cas_n /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_cas_n IO_TYPE SSTL18_II;
output  ddr2_sdramem_ddr_we_n /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_we_n IO_TYPE SSTL18_II;
output [`CS_WIDTH-1:0]  ddr2_sdramem_ddr_cs_n /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_cs_n IO_TYPE SSTL18_II;
output [`CS_WIDTH-1:0]  ddr2_sdramem_ddr_odt /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_odt IO_TYPE SSTL18_II;
output [`DATA_WIDTH/8-1:0]  ddr2_sdramem_ddr_dm /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_dm IO_TYPE SSTL18_II;
output [`BNK_WDTH-1:0]  ddr2_sdramem_ddr_ba /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_ba IO_TYPE SSTL18_II;
output [`ROW_WIDTH-1:0]  ddr2_sdramem_ddr_addr /* synthesis IO_TYPE="SSTL18_II" */;
//pragma attribute ddr2_sdramem_ddr_addr IO_TYPE SSTL18_II;

wire [31:0] LM32I_ADR_O;
wire [31:0] LM32I_DAT_O;
wire [31:0] LM32I_DAT_I;
wire [3:0] LM32I_SEL_O;
wire   LM32I_WE_O;
wire   LM32I_ACK_I;
wire   LM32I_ERR_I;
wire   LM32I_RTY_I;
wire [2:0] LM32I_CTI_O;
wire [1:0] LM32I_BTE_O;
wire   LM32I_LOCK_O;
wire   LM32I_CYC_O;
wire   LM32I_STB_O;
wire [31:0] LM32D_ADR_O;
wire [31:0] LM32D_DAT_O;
wire [31:0] LM32D_DAT_I;
wire [3:0] LM32D_SEL_O;
wire   LM32D_WE_O;
wire   LM32D_ACK_I;
wire   LM32D_ERR_I;
wire   LM32D_RTY_I;
wire [2:0] LM32D_CTI_O;
wire [1:0] LM32D_BTE_O;
wire   LM32D_LOCK_O;
wire   LM32D_CYC_O;
wire   LM32D_STB_O;
wire [31:0] LM32DEBUG_DAT_O;
wire   LM32DEBUG_ACK_O;
wire   LM32DEBUG_ERR_O;
wire   LM32DEBUG_RTY_O;
wire LM32DEBUG_en;
wire [31:0] LM32interrupt_n;
`ifdef CFG_USER_ENABLED
input [31:0]  LM32user_result;
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
input  LM32user_complete;
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
output  LM32user_valid;
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
output [10:0]  LM32user_opcode;
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
output [31:0]  LM32user_operand_0;
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
output [31:0]  LM32user_operand_1;
`endif // CFG_USER_ENABLED

wire [31:0] uartUART_DAT_O;
wire   uartUART_ACK_O;
wire   uartUART_ERR_O;
wire   uartUART_RTY_O;
wire uartUART_en;
wire uartINTR;
input  uartSIN;
output  uartSOUT;
`ifdef RXRDY_ENABLE
output  uartRXRDY_N;
`endif // RXRDY_ENABLE
`ifdef TXRDY_ENABLE
output  uartTXRDY_N;
`endif // TXRDY_ENABLE
`ifdef MODEM
input  uartDCD_N;
`endif // MODEM
`ifdef MODEM
input  uartCTS_N;
`endif // MODEM
`ifdef MODEM
input  uartDSR_N;
`endif // MODEM
`ifdef MODEM
input  uartRI_N;
`endif // MODEM
`ifdef MODEM
output  uartDTR_N;
`endif // MODEM
`ifdef MODEM
output  uartRTS_N;
`endif // MODEM

wire [31:0] timer1S_DAT_O;
wire   timer1S_ACK_O;
wire   timer1S_ERR_O;
wire   timer1S_RTY_O;
wire timer1S_en;
wire timer1S_INT_O;

wire [31:0] spiSPI_DAT_O;
wire   spiSPI_ACK_O;
wire   spiSPI_ERR_O;
wire   spiSPI_RTY_O;
wire spiSPI_en;
wire spiSPI_INT_O;
input  spiMISO_MASTER;
output  spiMOSI_MASTER;
output [3-1:0] spiSS_N_MASTER;
output  spiSCLK_MASTER;

wire [31:0] slave_passthruS_DAT_O;
wire   slave_passthruS_ACK_O;
wire   slave_passthruS_ERR_O;
wire   slave_passthruS_RTY_O;
wire slave_passthruS_en;
wire slave_passthruINTR_O;
output  slave_passthruclk;
output  slave_passthrurst;
output [31:0]  slave_passthruslv_adr;
output [31:0]  slave_passthruslv_master_data;
input [31:0]  slave_passthruslv_slave_data;
output  slave_passthruslv_strb;
output  slave_passthruslv_cyc;
input  slave_passthruslv_ack;
input  slave_passthruslv_err;
input  slave_passthruslv_rty;
output [3:0]  slave_passthruslv_sel;
output  slave_passthruslv_we;
output [1:0]  slave_passthruslv_bte;
output [2:0]  slave_passthruslv_cti;
output  slave_passthruslv_lock;
input  slave_passthruintr_active_high;
wire reset_i = !reset_n;


wire one_zero = 1'b0;
wire[1:0] two_zero = 2'b00;
wire[2:0] three_zero = 3'b000;
wire[3:0] four_zero = 4'b0000;
wire[31:0] thirtytwo_zero = 32'b0000_0000_0000_0000_0000_0000_0000_0000;

wire clk_pll_o;
`ifdef LATTICE_FAMILY_SC
lplib pll_inst(.clk(clk_i),.clkop(clk_pll_o),.lock(),.clkos());
`elsif LATTICE_FAMILY_SCM
lplib pll_inst(.clk(clk_i),.clkop(clk_pll_o),.lock(),.clkos());
`else
lplib pll_inst(.CLK(clk_i),.RESET(reset_i),.CLKOP(clk_pll_o),.LOCK());
`endif
arbiter2 arbiter (
.WBM0_ADR_O(LM32I_ADR_O),
.WBM0_DAT_O(LM32I_DAT_O),
.WBM0_DAT_I(LM32I_DAT_I),
.WBM0_SEL_O(LM32I_SEL_O),
.WBM0_WE_O(LM32I_WE_O),
.WBM0_ACK_I(LM32I_ACK_I),
.WBM0_ERR_I(LM32I_ERR_I),
.WBM0_RTY_I(LM32I_RTY_I),
.WBM0_CTI_O(LM32I_CTI_O),
.WBM0_BTE_O(LM32I_BTE_O),
.WBM0_LOCK_O(LM32I_LOCK_O),
.WBM0_CYC_O(LM32I_CYC_O),
.WBM0_STB_O(LM32I_STB_O),
.WBM1_ADR_O(LM32D_ADR_O),
.WBM1_DAT_O(LM32D_DAT_O),
.WBM1_DAT_I(LM32D_DAT_I),
.WBM1_SEL_O(LM32D_SEL_O),
.WBM1_WE_O(LM32D_WE_O),
.WBM1_ACK_I(LM32D_ACK_I),
.WBM1_ERR_I(LM32D_ERR_I),
.WBM1_RTY_I(LM32D_RTY_I),
.WBM1_CTI_O(LM32D_CTI_O),
.WBM1_BTE_O(LM32D_BTE_O),
.WBM1_LOCK_O(LM32D_LOCK_O),
.WBM1_CYC_O(LM32D_CYC_O),
.WBM1_STB_O(LM32D_STB_O),
.WBS_ADR_I(SHAREDBUS_ADR_I),
.WBS_DAT_I(SHAREDBUS_DAT_I),
.WBS_DAT_O(SHAREDBUS_DAT_O),
.WBS_SEL_I(SHAREDBUS_SEL_I),
.WBS_WE_I(SHAREDBUS_WE_I),
.WBS_ACK_O(SHAREDBUS_ACK_O),
.WBS_ERR_O(SHAREDBUS_ERR_O),
.WBS_RTY_O(SHAREDBUS_RTY_O),
.WBS_CTI_I(SHAREDBUS_CTI_I),
.WBS_BTE_I(SHAREDBUS_BTE_I),
.WBS_LOCK_I(SHAREDBUS_LOCK_I),
.WBS_CYC_I(SHAREDBUS_CYC_I),
.WBS_STB_I(SHAREDBUS_STB_I),
.clk(clk_pll_o), .reset(reset_i));
assign SHAREDBUS_DAT_O = 
gpioGPIO_en ? gpioGPIO_DAT_O : 
ebrEBR_en ? ebrEBR_DAT_O : 
ts_mac_coreA_en ? ts_mac_coreA_DAT_O : 
timer0S_en ? timer0S_DAT_O : 
ddr2_sdramDDR2_en ? ddr2_sdramDDR2_DAT_O : 
LM32DEBUG_en ? LM32DEBUG_DAT_O : 
uartUART_en ? uartUART_DAT_O : 
timer1S_en ? timer1S_DAT_O : 
spiSPI_en ? spiSPI_DAT_O : 
slave_passthruS_en ? slave_passthruS_DAT_O : 
0;
assign SHAREDBUS_ERR_O = SHAREDBUS_STB_I & !(
gpioGPIO_en | 
ebrEBR_en | 
ts_mac_coreA_en | 
timer0S_en | 
ddr2_sdramDDR2_en | 
LM32DEBUG_en | 
uartUART_en | 
timer1S_en | 
spiSPI_en | 
slave_passthruS_en | 
0);
assign SHAREDBUS_ACK_O = 
gpioGPIO_en ? gpioGPIO_ACK_O : 
ebrEBR_en ? ebrEBR_ACK_O : 
ts_mac_coreA_en ? ts_mac_coreA_ACK_O : 
timer0S_en ? timer0S_ACK_O : 
ddr2_sdramDDR2_en ? ddr2_sdramDDR2_ACK_O : 
LM32DEBUG_en ? LM32DEBUG_ACK_O : 
uartUART_en ? uartUART_ACK_O : 
timer1S_en ? timer1S_ACK_O : 
spiSPI_en ? spiSPI_ACK_O : 
slave_passthruS_en ? slave_passthruS_ACK_O : 
0;
assign SHAREDBUS_RTY_O = 
gpioGPIO_en ? gpioGPIO_RTY_O : 
ebrEBR_en ? ebrEBR_RTY_O : 
ts_mac_coreA_en ? ts_mac_coreA_RTY_O : 
timer0S_en ? timer0S_RTY_O : 
ddr2_sdramDDR2_en ? ddr2_sdramDDR2_RTY_O : 
LM32DEBUG_en ? LM32DEBUG_RTY_O : 
uartUART_en ? uartUART_RTY_O : 
timer1S_en ? timer1S_RTY_O : 
spiSPI_en ? spiSPI_RTY_O : 
slave_passthruS_en ? slave_passthruS_RTY_O : 
0;
assign gpioGPIO_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1000000000000000010);
gpio 
#(
.OUTPUT_PORTS_ONLY(1),
.INPUT_PORTS_ONLY(0),
.TRISTATE_PORTS(0),
.BOTH_INPUT_AND_OUTPUT(0),
.DATA_WIDTH(32'h4),
.INPUT_WIDTH(32'h1),
.OUTPUT_WIDTH(32'h1),
.IRQ_MODE(0),
.LEVEL(0),
.EDGE(1),
.EITHER_EDGE_IRQ(0),
.POSE_EDGE_IRQ(1),
.NEGE_EDGE_IRQ(0))
 gpio( 
.GPIO_ADR_I(SHAREDBUS_ADR_I),
.GPIO_DAT_I(SHAREDBUS_DAT_I),
.GPIO_DAT_O(gpioGPIO_DAT_O),
.GPIO_SEL_I(SHAREDBUS_SEL_I),
.GPIO_WE_I(SHAREDBUS_WE_I),
.GPIO_ACK_O(gpioGPIO_ACK_O),
.GPIO_ERR_O(gpioGPIO_ERR_O),
.GPIO_RTY_O(gpioGPIO_RTY_O),
.GPIO_CTI_I(SHAREDBUS_CTI_I),
.GPIO_BTE_I(SHAREDBUS_BTE_I),
.GPIO_LOCK_I(SHAREDBUS_LOCK_I),
.GPIO_CYC_I(SHAREDBUS_CYC_I & gpioGPIO_en),
.GPIO_STB_I(SHAREDBUS_STB_I & gpioGPIO_en),
.PIO_IN(),
.PIO_BOTH_IN(),
.PIO_OUT(gpioPIO_OUT),
.PIO_BOTH_OUT(),
.PIO_IO(),
.IRQ_O(gpioIRQ_O),
.CLK_I(clk_pll_o), .RST_I(reset_i));
assign ebrEBR_en = ( SHAREDBUS_ADR_I[31:15] == 17'b00000100000000000);
wb_ebr_ctrl 
#(
.SIZE(32768),
.EBR_DATA_WIDTH(32),
.INIT_FILE_NAME("none"),
.INIT_FILE_FORMAT("hex"))
 ebr( 
.EBR_ADR_I(SHAREDBUS_ADR_I),
.EBR_DAT_I(SHAREDBUS_DAT_I),
.EBR_DAT_O(ebrEBR_DAT_O),
.EBR_SEL_I(SHAREDBUS_SEL_I),
.EBR_WE_I(SHAREDBUS_WE_I),
.EBR_ACK_O(ebrEBR_ACK_O),
.EBR_ERR_O(ebrEBR_ERR_O),
.EBR_RTY_O(ebrEBR_RTY_O),
.EBR_CTI_I(SHAREDBUS_CTI_I),
.EBR_BTE_I(SHAREDBUS_BTE_I),
.EBR_LOCK_I(SHAREDBUS_LOCK_I),
.EBR_CYC_I(SHAREDBUS_CYC_I & ebrEBR_en),
.EBR_STB_I(SHAREDBUS_STB_I & ebrEBR_en),
.CLK_I (clk_pll_o), .RST_I (reset_i));
assign timer0S_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1000000000000000001);
timer 
#(
.PERIOD_NUM(32'h14),
.PERIOD_WIDTH(32'h20),
.WRITEABLE_PERIOD(1),
.READABLE_SNAPSHOT(1),
.START_STOP_CONTROL(1),
.WATCHDOG(0))
 timer0( 
.S_ADR_I(SHAREDBUS_ADR_I),
.S_DAT_I(SHAREDBUS_DAT_I),
.S_DAT_O(timer0S_DAT_O),
.S_SEL_I(SHAREDBUS_SEL_I),
.S_WE_I(SHAREDBUS_WE_I),
.S_ACK_O(timer0S_ACK_O),
.S_ERR_O(timer0S_ERR_O),
.S_RTY_O(timer0S_RTY_O),
.S_CTI_I(SHAREDBUS_CTI_I),
.S_BTE_I(SHAREDBUS_BTE_I),
.S_LOCK_I(SHAREDBUS_LOCK_I),
.S_CYC_I(SHAREDBUS_CYC_I & timer0S_en),
.S_STB_I(SHAREDBUS_STB_I & timer0S_en),
.S_INT_O(timer0S_INT_O),
.CLK_I (clk_pll_o), .RST_I (reset_i));
assign ddr2_sdramDDR2_en = ( SHAREDBUS_ADR_I[31:25] == 7'b0000100);
wb_ddr2_ctl_v67 
#(
.SYS_FREQ("75"),
.SYS_FREQ_INT(75),
.DDR_FREQ("150"),
.BST_CNT_READ(32'h1))
 ddr2_sdram( 
.DDR2_ADR_I(SHAREDBUS_ADR_I),
.DDR2_DAT_I(SHAREDBUS_DAT_I),
.DDR2_DAT_O(ddr2_sdramDDR2_DAT_O),
.DDR2_SEL_I(SHAREDBUS_SEL_I),
.DDR2_WE_I(SHAREDBUS_WE_I),
.DDR2_ACK_O(ddr2_sdramDDR2_ACK_O),
.DDR2_ERR_O(ddr2_sdramDDR2_ERR_O),
.DDR2_RTY_O(ddr2_sdramDDR2_RTY_O),
.DDR2_CTI_I(SHAREDBUS_CTI_I),
.DDR2_BTE_I(SHAREDBUS_BTE_I),
.DDR2_LOCK_I(SHAREDBUS_LOCK_I),
.DDR2_CYC_I(SHAREDBUS_CYC_I & ddr2_sdramDDR2_en),
.DDR2_STB_I(SHAREDBUS_STB_I & ddr2_sdramDDR2_en),
.em_ddr_data(ddr2_sdramem_ddr_data),
.em_ddr_dqs(ddr2_sdramem_ddr_dqs),
.em_ddr_clk(ddr2_sdramem_ddr_clk),
.em_ddr_cke(ddr2_sdramem_ddr_cke),
.em_ddr_ras_n(ddr2_sdramem_ddr_ras_n),
.em_ddr_cas_n(ddr2_sdramem_ddr_cas_n),
.em_ddr_we_n(ddr2_sdramem_ddr_we_n),
.em_ddr_cs_n(ddr2_sdramem_ddr_cs_n),
.em_ddr_odt(ddr2_sdramem_ddr_odt),
.em_ddr_dm(ddr2_sdramem_ddr_dm),
.em_ddr_ba(ddr2_sdramem_ddr_ba),
.em_ddr_addr(ddr2_sdramem_ddr_addr),
.CLK_I (clk_pll_o), .rst_i (reset_i));
assign LM32DEBUG_en = ( SHAREDBUS_ADR_I[31:14] == 18'b000000000000000000);
lm32_top 
 LM32( 
.I_ADR_O(LM32I_ADR_O),
.I_DAT_O(LM32I_DAT_O),
.I_DAT_I(LM32I_DAT_I),
.I_SEL_O(LM32I_SEL_O),
.I_WE_O(LM32I_WE_O),
.I_ACK_I(LM32I_ACK_I),
.I_ERR_I(LM32I_ERR_I),
.I_RTY_I(LM32I_RTY_I),
.I_CTI_O(LM32I_CTI_O),
.I_BTE_O(LM32I_BTE_O),
.I_LOCK_O(LM32I_LOCK_O),
.I_CYC_O(LM32I_CYC_O),
.I_STB_O(LM32I_STB_O),
.D_ADR_O(LM32D_ADR_O),
.D_DAT_O(LM32D_DAT_O),
.D_DAT_I(LM32D_DAT_I),
.D_SEL_O(LM32D_SEL_O),
.D_WE_O(LM32D_WE_O),
.D_ACK_I(LM32D_ACK_I),
.D_ERR_I(LM32D_ERR_I),
.D_RTY_I(LM32D_RTY_I),
.D_CTI_O(LM32D_CTI_O),
.D_BTE_O(LM32D_BTE_O),
.D_LOCK_O(LM32D_LOCK_O),
.D_CYC_O(LM32D_CYC_O),
.D_STB_O(LM32D_STB_O),
.DEBUG_ADR_I(SHAREDBUS_ADR_I),
.DEBUG_DAT_I(SHAREDBUS_DAT_I),
.DEBUG_DAT_O(LM32DEBUG_DAT_O),
.DEBUG_SEL_I(SHAREDBUS_SEL_I),
.DEBUG_WE_I(SHAREDBUS_WE_I),
.DEBUG_ACK_O(LM32DEBUG_ACK_O),
.DEBUG_ERR_O(LM32DEBUG_ERR_O),
.DEBUG_RTY_O(LM32DEBUG_RTY_O),
.DEBUG_CTI_I(SHAREDBUS_CTI_I),
.DEBUG_BTE_I(SHAREDBUS_BTE_I),
.DEBUG_LOCK_I(SHAREDBUS_LOCK_I),
.DEBUG_CYC_I(SHAREDBUS_CYC_I & LM32DEBUG_en),
.DEBUG_STB_I(SHAREDBUS_STB_I & LM32DEBUG_en),
`ifdef CFG_USER_ENABLED
.user_result(LM32user_result),
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
.user_complete(LM32user_complete),
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
.user_valid(LM32user_valid),
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
.user_opcode(LM32user_opcode),
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
.user_operand_0(LM32user_operand_0),
`endif // CFG_USER_ENABLED
`ifdef CFG_USER_ENABLED
.user_operand_1(LM32user_operand_1),
`endif // CFG_USER_ENABLED
.interrupt_n(LM32interrupt_n),
.clk_i (clk_pll_o), .rst_i (reset_i));
assign uartUART_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1000000000000000011);
uart_core 
#(
.ADDRWIDTH(5),
.DATAWIDTH(8),
.CLK_IN_MHZ(75),
.BAUD_RATE(115200),
.FIFO(0),
.STDOUT_SIM(0),
.STDOUT_SIMFAST(0))
 uart( 
.UART_ADR_I(SHAREDBUS_ADR_I),
.UART_DAT_I(SHAREDBUS_DAT_I),
.UART_DAT_O(uartUART_DAT_O),
.UART_SEL_I(SHAREDBUS_SEL_I),
.UART_WE_I(SHAREDBUS_WE_I),
.UART_ACK_O(uartUART_ACK_O),
.UART_ERR_O(uartUART_ERR_O),
.UART_RTY_O(uartUART_RTY_O),
.UART_CTI_I(SHAREDBUS_CTI_I),
.UART_BTE_I(SHAREDBUS_BTE_I),
.UART_LOCK_I(SHAREDBUS_LOCK_I),
.UART_CYC_I(SHAREDBUS_CYC_I & uartUART_en),
.UART_STB_I(SHAREDBUS_STB_I & uartUART_en),
.SIN(uartSIN),
.SOUT(uartSOUT),
`ifdef RXRDY_ENABLE
.RXRDY_N(uartRXRDY_N),
`endif // RXRDY_ENABLE
`ifdef TXRDY_ENABLE
.TXRDY_N(uartTXRDY_N),
`endif // TXRDY_ENABLE
`ifdef MODEM
.DCD_N(uartDCD_N),
`endif // MODEM
`ifdef MODEM
.CTS_N(uartCTS_N),
`endif // MODEM
`ifdef MODEM
.DSR_N(uartDSR_N),
`endif // MODEM
`ifdef MODEM
.RI_N(uartRI_N),
`endif // MODEM
`ifdef MODEM
.DTR_N(uartDTR_N),
`endif // MODEM
`ifdef MODEM
.RTS_N(uartRTS_N),
`endif // MODEM
.INTR(uartINTR),
.CLK(clk_pll_o), .RESET(reset_i));
assign timer1S_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1000000000000000101);
timer 
#(
.PERIOD_NUM(32'h14),
.PERIOD_WIDTH(32'h20),
.WRITEABLE_PERIOD(1),
.READABLE_SNAPSHOT(1),
.START_STOP_CONTROL(1),
.WATCHDOG(0))
 timer1( 
.S_ADR_I(SHAREDBUS_ADR_I),
.S_DAT_I(SHAREDBUS_DAT_I),
.S_DAT_O(timer1S_DAT_O),
.S_SEL_I(SHAREDBUS_SEL_I),
.S_WE_I(SHAREDBUS_WE_I),
.S_ACK_O(timer1S_ACK_O),
.S_ERR_O(timer1S_ERR_O),
.S_RTY_O(timer1S_RTY_O),
.S_CTI_I(SHAREDBUS_CTI_I),
.S_BTE_I(SHAREDBUS_BTE_I),
.S_LOCK_I(SHAREDBUS_LOCK_I),
.S_CYC_I(SHAREDBUS_CYC_I & timer1S_en),
.S_STB_I(SHAREDBUS_STB_I & timer1S_en),
.S_INT_O(timer1S_INT_O),
.CLK_I (clk_pll_o), .RST_I (reset_i));
assign spiSPI_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1000000000000000110);
spi 
#(
.MASTER(1),
.SLAVE_NUMBER(32'h3),
.CLOCK_SEL(7),
.CLKCNT_WIDTH(16),
.INTERVAL_LENGTH(2),
.DATA_LENGTH(8),
.SHIFT_DIRECTION(0),
.CLOCK_PHASE(0),
.CLOCK_POLARITY(1))
 spi( 
.SPI_ADR_I(SHAREDBUS_ADR_I),
.SPI_DAT_I(SHAREDBUS_DAT_I),
.SPI_DAT_O(spiSPI_DAT_O),
.SPI_SEL_I(SHAREDBUS_SEL_I),
.SPI_WE_I(SHAREDBUS_WE_I),
.SPI_ACK_O(spiSPI_ACK_O),
.SPI_ERR_O(spiSPI_ERR_O),
.SPI_RTY_O(spiSPI_RTY_O),
.SPI_CTI_I(SHAREDBUS_CTI_I),
.SPI_BTE_I(SHAREDBUS_BTE_I),
.SPI_LOCK_I(SHAREDBUS_LOCK_I),
.SPI_CYC_I(SHAREDBUS_CYC_I & spiSPI_en),
.SPI_STB_I(SHAREDBUS_STB_I & spiSPI_en),
.MISO_MASTER(spiMISO_MASTER),
.MOSI_MASTER(spiMOSI_MASTER),
.SS_N_MASTER(spiSS_N_MASTER),
.SCLK_MASTER(spiSCLK_MASTER),
.MISO_SLAVE(),
.MOSI_SLAVE(),
.SS_N_SLAVE(),
.SCLK_SLAVE(),
.SPI_INT_O(spiSPI_INT_O),
.CLK_I(clk_pll_o), .RST_I(reset_i));
assign slave_passthruS_en = ( SHAREDBUS_ADR_I[31:13] == 19'b1001000000000000000);
slave_passthru 
 slave_passthru( 
.S_ADR_I(SHAREDBUS_ADR_I),
.S_DAT_I(SHAREDBUS_DAT_I),
.S_DAT_O(slave_passthruS_DAT_O),
.S_SEL_I(SHAREDBUS_SEL_I),
.S_WE_I(SHAREDBUS_WE_I),
.S_ACK_O(slave_passthruS_ACK_O),
.S_ERR_O(slave_passthruS_ERR_O),
.S_RTY_O(slave_passthruS_RTY_O),
.S_CTI_I(SHAREDBUS_CTI_I),
.S_BTE_I(SHAREDBUS_BTE_I),
.S_LOCK_I(SHAREDBUS_LOCK_I),
.S_CYC_I(SHAREDBUS_CYC_I),
.S_STB_I(SHAREDBUS_STB_I),
.clk(slave_passthruclk),
.rst(slave_passthrurst),
.slv_adr(slave_passthruslv_adr),
.slv_master_data(slave_passthruslv_master_data),
.slv_slave_data(slave_passthruslv_slave_data),
.slv_strb(slave_passthruslv_strb),
.slv_cyc(slave_passthruslv_cyc),
.slv_ack(slave_passthruslv_ack),
.slv_err(slave_passthruslv_err),
.slv_rty(slave_passthruslv_rty),
.slv_sel(slave_passthruslv_sel),
.slv_we(slave_passthruslv_we),
.slv_bte(slave_passthruslv_bte),
.slv_cti(slave_passthruslv_cti),
.slv_lock(slave_passthruslv_lock),
.intr_active_high(slave_passthruintr_active_high),
.INTR_O(slave_passthruINTR_O),
.CLK_I(clk_pll_o), .RST_I(reset_i));
assign LM32interrupt_n[2] = ts_mac_coreINTR_N ;
assign LM32interrupt_n[1] = !timer0S_INT_O ;
assign LM32interrupt_n[0] = !uartINTR ;
assign LM32interrupt_n[3] = !timer1S_INT_O ;
assign LM32interrupt_n[4] = !spiSPI_INT_O ;
assign LM32interrupt_n[5] = !slave_passthruINTR_O ;
assign LM32interrupt_n[6] = 1;
assign LM32interrupt_n[7] = 1;
assign LM32interrupt_n[8] = 1;
assign LM32interrupt_n[9] = 1;
assign LM32interrupt_n[10] = 1;
assign LM32interrupt_n[11] = 1;
assign LM32interrupt_n[12] = 1;
assign LM32interrupt_n[13] = 1;
assign LM32interrupt_n[14] = 1;
assign LM32interrupt_n[15] = 1;
assign LM32interrupt_n[16] = 1;
assign LM32interrupt_n[17] = 1;
assign LM32interrupt_n[18] = 1;
assign LM32interrupt_n[19] = 1;
assign LM32interrupt_n[20] = 1;
assign LM32interrupt_n[21] = 1;
assign LM32interrupt_n[22] = 1;
assign LM32interrupt_n[23] = 1;
assign LM32interrupt_n[24] = 1;
assign LM32interrupt_n[25] = 1;
assign LM32interrupt_n[26] = 1;
assign LM32interrupt_n[27] = 1;
assign LM32interrupt_n[28] = 1;
assign LM32interrupt_n[29] = 1;
assign LM32interrupt_n[30] = 1;
assign LM32interrupt_n[31] = 1;
endmodule
