TARGET_FAMILY = virtex2p
XST_OPTIONS = -arch $(TARGET_FAMILY)
PART = xc2vp4-ff672-5

CORE_DIR = core
TOP = cpcievr220
BUILD_DIR = build/cpcievr220
DESIGN = $(BUILD_DIR)/$(TOP)
EDK_DIR = edk/cpcievr220
EDK_PRJ = system
VHDL_SRC = vhdl/buf_bsram.vhd \
        vhdl/databuf_rx.vhd \
        vhdl/event_dcm.vhd \
        vhdl/event_map_ram.vhd \
        vhdl/evr_pkg.vhd \
        vhdl/cpcievr220_pkg.vhd \
        vhdl/mgt_rx.vhd \
        vhdl/micrel_load.vhd \
        vhdl/opb_evr.vhd \
        vhdl/mx_counter.vhd \
        vhdl/pulse_generator.vhd \
        vhdl/recclk_out.vhd \
        vhdl/receiver.vhd \
        vhdl/refclock.vhd \
        vhdl/sync_domains.vhd \
        vhdl/cpcievr220.vhd \
        opb_pci9030/opb_pci9030.vhd \
        $(EDK_DIR)/hdl/$(EDK_PRJ).vhd
UCF_SRC = vhdl/cpcievr220.ucf
UT_SRC = vhdl/cpcievr220.ut
# This project is not using the PowerPC, no software project
# EXECUTABLE_ELF = $(EDK_DIR)/ppc405_1/code/executable.elf
# EDK_BMMFILE = $(EDK_DIR)/implementation/$(EDK_PRJ)_stub.bmm
# BMMFILE = $(BUILD_DIR)/edkBmmFile.bmm
# BMMFILE_BD = $(BUILD_DIR)/edkBmmFile_bd.bmm
# EDK_SW_SOURCES = $(EDK_DIR)/sw/linker_script \
#         $(EDK_DIR)/sw/sseq_control.c \
#         $(EDK_DIR)/sw/sseq_irq.S
FS_UPGRADE_HEAD = ip2k/cpcievr220.upgrade.head.bin
FS_IMAGE = build/cpcievr220/filesystem.bin

XST_SCRIPT = cpcievr220.xst_script

all: $(DESIGN).bit

$(FS_IMAGE): $(FS_UPGRADE_HEAD) $(DESIGN).bit
	cat $(FS_UPGRADE_HEAD) $(DESIGN).bit > $@

$(EDK_DIR)/hdl/$(EDK_PRJ).vhd: $(EDK_DIR)/$(EDK_PRJ).xmp \
        $(EDK_DIR)/$(EDK_PRJ).mhs $(EDK_DIR)/$(EDK_PRJ).mss
	make -f $(EDK_PRJ).make -C $(EDK_DIR) netlist

$(DESIGN).ngc : $(VHDL_SRC) $(XST_SCRIPT)
	xst -ifn $(XST_SCRIPT) -intstyle xflow

$(DESIGN).ngd : $(DESIGN).ngc $(UCF_SRC)
	ngdbuild -intstyle xflow -dd _ngo -uc $(UCF_SRC) \
        -sd $(CORE_DIR) -sd $(EDK_DIR)/implementation \
        -p $(PART) $(DESIGN).ngc $(DESIGN).ngd

$(DESIGN)_map.ncd : $(DESIGN).ngd
	map -intstyle xflow -p $(PART) -cm area -pr b -k 4 -c 100 -tx off \
        -o $(DESIGN)_map.ncd $(DESIGN).ngd $(DESIGN).pcf

$(DESIGN).ncd : $(DESIGN)_map.ncd
	par -w -intstyle xflow -ol std -t 1 $(DESIGN)_map.ncd $(DESIGN).ncd \
        $(DESIGN).pcf

$(DESIGN).bit : $(DESIGN).ncd $(UT_SRC)
	bitgen -intstyle xflow -f $(UT_SRC) $(DESIGN).ncd

clean:
	-rm -rf $(BUILD_DIR)/* xst/* vhdl/*~ *~ *.lso *.srp _ngo/* \
        xilinx_device_details.xml
	make -f $(EDK_PRJ).make -C $(EDK_DIR) clean
