TARGET_FAMILY = virtex5
XST_OPTIONS = -arch $(TARGET_FAMILY)
PART = xc5vfx70t-1-ff1136

CORE_DIR = core_v5
TOP = cpcievrtg
BUILD_DIR = build/cpcievrtg
DESIGN = $(BUILD_DIR)/$(TOP)
EDK_DIR = edk/cpcievrtg
EDK_PRJ = system
VHDL_SRC = vhdl/buf_bsram.vhd \
        vhdl/databuf_rx.vhd \
        vhdl/membuf_bsram_v5.vhd \
        vhdl/event_log.vhd \
        vhdl/log_ram_v5.vhd \
        vhdl/event_dcm.vhd \
        vhdl/event_map_ram.vhd \
        vhdl/map_ram_v5.vhd \
        vhdl/cpcievrtg_pkg.vhd \
        vhdl/evr_pkg.vhd \
        vhdl/local_clock.vhd \
        vhdl/mgt_cmlout_bram.vhd \
        vhdl/mgt_rx.vhd \
        vhdl/micrel_load.vhd \
        vhdl/DPRAM_2k_8_32_v5.vhd \
        vhdl/sfp_serial.vhd \
        vhdl/config_RAM.vhd \
        vhdl/transmitter.vhd \
        vhdl/mx_counter.vhd \
        vhdl/memory_buffer.vhd \
        vhdl/opb_evr.vhd \
        vhdl/pulse_generator.vhd \
        vhdl/recclk_out.vhd \
        vhdl/receiver.vhd \
        vhdl/refclock.vhd \
        vhdl/sync_domains.vhd \
        vhdl/adi.vhd \
        plb_ubicom/plbv46_ubicom_master.vhd \
        vhdl/gtx_cmlout_bram.vhd \
        vhdl/cpcievrtg_gtx_tile.vhd \
        vhdl/cpcievrtg_gtx.vhd \
        vhdl/cpcievrtg_cml_gtx.vhd \
        vhdl/receiver_v5fxt.vhd \
        vhdl/cpcievrtg.vhd \
        $(EDK_DIR)/hdl/$(EDK_PRJ).vhd
UCF_SRC = vhdl/cpcievrtg.ucf
UT_SRC = vhdl/cpcievrtg.ut
# This project is not using the PowerPC, no software project
# EXECUTABLE_ELF = $(EDK_DIR)/ppc405_1/code/executable.elf
# EDK_BMMFILE = $(EDK_DIR)/implementation/$(EDK_PRJ)_stub.bmm
# BMMFILE = $(BUILD_DIR)/edkBmmFile.bmm
# BMMFILE_BD = $(BUILD_DIR)/edkBmmFile_bd.bmm
# EDK_SW_SOURCES = $(EDK_DIR)/sw/linker_script \
#         $(EDK_DIR)/sw/sseq_control.c \
#         $(EDK_DIR)/sw/sseq_irq.S
#FS_UPGRADE_HEAD = ip2k/cpcifct.upgrade.head.bin
#FS_IMAGE = build/cpcievrtg/filesystem.bin

XST_SCRIPT = cpcievrtg.xst_script

all: $(DESIGN).bit

$(FS_IMAGE): $(FS_UPGRADE_HEAD) $(DESIGN).bit
	cat $(FS_UPGRADE_HEAD) $(DESIGN).bit > $@

$(EDK_DIR)/hdl/$(EDK_PRJ).vhd: $(EDK_DIR)/$(EDK_PRJ).xmp \
        $(EDK_DIR)/$(EDK_PRJ).mhs $(EDK_DIR)/$(EDK_PRJ).mss
	make -f $(EDK_PRJ).make -C $(EDK_DIR) netlist

$(DESIGN).ngc : $(VHDL_SRC) $(XST_SCRIPT)
	xst -ifn $(XST_SCRIPT) -intstyle xflow

$(DESIGN).ngd : $(DESIGN).ngc $(UCF_SRC)
	ngdbuild -intstyle xflow -dd _ngo -uc $(UCF_SRC) \
        -sd $(CORE_DIR) -sd $(EDK_DIR)/implementation \
        -p $(PART) $(DESIGN).ngc $(DESIGN).ngd

$(DESIGN)_map.ncd : $(DESIGN).ngd
	export XIL_PAR_DEBUG_IOCLKPLACER=1; \
	map -intstyle xflow -p $(PART) -w -logic_opt off -ol high \
        -t 1 -cm area -pr off -lc off -power off \
        -o $(DESIGN)_map.ncd $(DESIGN).ngd $(DESIGN).pcf

$(DESIGN).ncd : $(DESIGN)_map.ncd
	par -w -intstyle xflow -ol std -t 1 $(DESIGN)_map.ncd $(DESIGN).ncd \
        $(DESIGN).pcf

$(DESIGN).bit : $(DESIGN).ncd $(UT_SRC)
	bitgen -intstyle xflow -f $(UT_SRC) $(DESIGN).ncd

clean:
	-rm -rf $(BUILD_DIR)/* xst/* vhdl/*~ *~ *.lso *.srp _ngo/* \
        xilinx_device_details.xml
	make -f $(EDK_PRJ).make -C $(EDK_DIR) clean
